<template>
    <div class="row">
        <div class="col-12 mb-2">
            <h4 class="text-decoration-underline text-purple">Tűzoltó készülék üzemeltetési napló</h4>
            <button class="btn btn-warning text-white mt-5" @click="create">
                <Fa :icon="faPlus"/>
                Új tűzoltó készülék
            </button>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <div class="table-responsive mt-3 mb-2">
                <extinguisherTable v-bind:extinguishers="extinguishers"
                                   @createMaintenance="createMaintenance"
                                   @maintenanceList="maintenanceList"
                                   @edit="edit"
                ></extinguisherTable>
            </div>
            <div class="float-end">
                <Button label="Dokumentum készítése" icon="pi pi-print" severity="secondary"
                        @click="createDocument" :loading="documentDownload" :disabled="documentDownload || extinguishers.length === 0"/>
            </div>
        </div>
    </div>

    <Dialog v-model:visible="createModalOpen" :header="extinguisher.id === 0 ? header : updateHeader" modal
            :style="{ width: '60vw', height: '100%', maxWidth: '700px' }"
            :breakpoints="{ '960px': '75vw', '641px': '100vw' }"
    >
        <extinguisherForm v-bind:extinguisher="extinguisher" v-bind:types="extinguisherTypes"></extinguisherForm>
        <template #footer>
            <Button :label="extinguisher.id === 0 ? 'Mentés' : 'Módosítás'" icon="pi pi-check" severity="success"
                    @click="save" :loading="formLoading" :disabled="formLoading"/>
        </template>
    </Dialog>

    <Dialog v-model:visible="maintenanceModalOpen" :header="!maintenanceEditMode ? maintenanceHeader : updateMaintenanceHeader" modal
            :style="{ width: '60vw', maxWidth: '750px' }"
            :breakpoints="{ '960px': '75vw', '641px': '100vw' }"
    >
        <maintenanceForm v-bind:maintenance="maintenance"
                         v-bind:maintenanceEditMode="maintenanceEditMode">
        </maintenanceForm>
        <template #footer>
            <Button :label="!maintenanceEditMode ? 'Mentés' : 'Módosítás'" :disabled="formLoading"
                    icon="pi pi-check" severity="success" @click="saveMaintenance" :loading="formLoading"/>
        </template>
    </Dialog>

    <Dialog v-model:visible="maintenanceListModalOpen" :header="maintenanceListHeader" modal
            :style="{ width: '60vw', maxWidth: '750px' }"
            :breakpoints="{ '960px': '75vw', '641px': '100vw' }"
    >
        <maintenanceList v-bind:maintenances="maintenances" @edit="editMaintenance" @delete="deleteMaintenanceModal"></maintenanceList>
    </Dialog>

    <Dialog v-model:visible="maintenanceDeleteModalOpen" :header="maintenanceDeleteHeader" modal
            :style="{ width: '60vw', maxWidth: '450px' }"
            :breakpoints="{ '960px': '75vw', '641px': '100vw' }"
    >
        <template #footer>
            <Button label="Törlés" :disabled="formLoading"
                    icon="pi pi-check" severity="success" @click="deleteMaintenance" :loading="formLoading"/>
        </template>
    </Dialog>

    <Toast position="bottom-right"/>
</template>

<script>
import Fa from 'vue-fa'
import {faPlus} from '@fortawesome/free-solid-svg-icons'
import Button from 'primevue/button';
import Dialog from 'primevue/dialog';
import ExtinguisherForm from "./Form.vue";
import ExtinguisherTable from "./Table.vue";
import Toast from 'primevue/toast';
import {ApiService} from "../../services/ApiService";
import MaintenanceForm from "./MaintenanceForm.vue";
import moment from "moment";
import MaintenanceList from "./MaintenanceList.vue";

export default {
    name: "extinguisherList",
    components: {
        MaintenanceForm,
        MaintenanceList,
        ExtinguisherTable,
        ExtinguisherForm,
        Fa,
        Button,
        Dialog,
        Toast,
        ApiService
    },
    data() {
        return {
            header: 'Tűzoltó készülék hozzáadása',
            updateHeader: 'Tűzoltó készülék szerkesztése',
            maintenanceHeader: 'Új karbantartás',
            updateMaintenanceHeader: 'Karbantartás szerkesztése',
            maintenanceListHeader: 'Karbantartási lista',
            maintenanceDeleteHeader: 'Karbantartás törlés megerősítése',
            maintenance: {},
            extinguisher: {},
            extinguishers: [],
            extinguisherTypes: [],
            maintenances: [],
            createModalOpen: false,
            maintenanceModalOpen: false,
            maintenanceListModalOpen: false,
            maintenanceEditMode: false,
            maintenanceDeleteModalOpen: false,
            formLoading: false,
            documentDownload: false,
            apiService: new ApiService(),
        }
    },
    setup() {
        return {
            faPlus
        }
    },
    mounted() {
        this.getData()
        this.getAllExtinguisherTypes()
        this.initExtinguisher()
        this.initMaintenance()
    },
    methods: {
        initMaintenance(extinguisherId, maintenance = null) {
            this.maintenance = {
                id: maintenance ? maintenance.id : 0,
                extinguisherId: extinguisherId,
                maintenanceTypeRef: maintenance ? maintenance.maintenanceTypeRef : 1,
                maintenancePeriod: maintenance ? maintenance.maintenancePeriod : '',
                maintenanceDate: maintenance ? maintenance.maintenanceDate : moment().format('Y-MM-DD'),
                note: ''
            };
        },
        initExtinguisher() {
            this.extinguisher = {
                id: 0,
                premises: 1,
                identifier: '',
                location: '',
                extinguisherType: 0,
                serialNumber: '',
                productionTime: {
                    year: '',
                    month: '',
                    day: '',
                },
                note: '',
                clone: ''
            };
        },
        async getData() {
            this.apiService.getAllExtinguishers().then(response => {
                this.extinguishers = response.data
            }).catch(error => {
                this.$toast.add({
                    severity: 'error',
                    summary: 'Sikertelen művelet!',
                    detail: error.response.data.message,
                    life: 5000
                });
            });
        },
        async getAllExtinguisherTypes() {
            this.apiService.getAllExtinguisherTypes().then(response => {
                this.extinguisherTypes = response.data
            }).catch(error => {
                this.$toast.add({
                    severity: 'error',
                    summary: 'Sikertelen művelet!',
                    detail: error.response.data.message,
                    life: 5000
                });
            });
        },
        create() {
            this.initExtinguisher();
            this.createModalOpen = true;
        },
        edit(extinguisher) {
            this.extinguisher = extinguisher;
            this.createModalOpen = true;
        },
        createMaintenance(extinguisher) {
            let maintenance = extinguisher.lastMaintenance;
            this.initMaintenance(extinguisher.id, maintenance);
            this.maintenanceEditMode = false;
            this.maintenanceModalOpen = true;
        },
        maintenanceList(extinguisher) {
            this.maintenances = extinguisher.maintenances;
            this.maintenanceListModalOpen = true;
        },
        editMaintenance(maintenance) {
            this.maintenance = maintenance;
            this.maintenanceEditMode = true;
            this.maintenanceModalOpen = true;
        },
        async save() {
            this.formLoading = true;

            if (this.extinguisher.id === 0) {
                this.apiService.saveExtinguisher(this.extinguisher).then(() => {
                    this.formLoading = false;
                    this.createModalOpen = false;
                    this.initExtinguisher();
                    this.getData();

                    this.$toast.add({
                        severity: 'success',
                        summary: 'Sikeres mentés!',
                        detail: 'A tűzoltó készülék mentése sikeres.',
                        life: 5000
                    });
                }).catch(error => {
                    this.formLoading = false;

                    this.$toast.add({
                        severity: 'error',
                        summary: 'Sikertelen mentés!',
                        detail: error.response.data.message,
                        life: 5000
                    });
                })
            } else {
                this.apiService.updateExtinguisher(this.extinguisher).then(() => {
                    this.formLoading = false;
                    this.createModalOpen = false;
                    this.initExtinguisher();
                    this.getData();

                    this.$toast.add({
                        severity: 'success',
                        summary: 'Sikeres módosítás!',
                        detail: 'A tűzoltó készülék módosítása sikeres.',
                        life: 5000
                    });
                }).catch(error => {
                    this.formLoading = false;

                    this.$toast.add({
                        severity: 'error',
                        summary: 'Sikertelen módosítás!',
                        detail: error.response.data.message,
                        life: 5000
                    });
                })
            }

        },
        async saveMaintenance() {
            this.formLoading = true;
            this.maintenance.maintenanceDate = moment(this.maintenance.maintenanceDate).format('Y-MM-DD');

            if (!this.maintenanceEditMode) {
                this.apiService.saveMaintenance(this.maintenance).then(response => {
                    this.formLoading = false;
                    this.maintenanceModalOpen = false;
                    this.initMaintenance(response.data.id);
                    this.getData();

                    this.$toast.add({
                        severity: 'success',
                        summary: 'Sikeres mentés!',
                        detail: 'A tűzoltó készülékhez tartozó karbantartás mentése sikeres.',
                        life: 5000
                    });
                }).catch(error => {
                    this.formLoading = false;

                    this.$toast.add({
                        severity: 'error',
                        summary: 'Sikertelen mentés!',
                        detail: error.response.data.message,
                        life: 5000
                    });
                })
            } else {
                this.apiService.updateMaintenance(this.maintenance).then(response => {
                    this.formLoading = false;
                    this.maintenanceModalOpen = false;
                    this.maintenanceListModalOpen = false;
                    this.initMaintenance(response.data.id);
                    this.getData();

                    this.$toast.add({
                        severity: 'success',
                        summary: 'Sikeres mentés!',
                        detail: 'A tűzoltó készülékhez tartozó karbantartás módosítása sikeres.',
                        life: 5000
                    });
                }).catch(error => {
                    this.formLoading = false;

                    this.$toast.add({
                        severity: 'error',
                        summary: 'Sikertelen módosítás!',
                        detail: error.response.data.message,
                        life: 5000
                    });
                })
            }
        },
        deleteMaintenanceModal(maintenance) {
            this.maintenance = maintenance;
            this.maintenanceDeleteModalOpen = true;
        },
        deleteMaintenance() {
            this.formLoading = true;

            this.apiService.deleteMaintenance(this.maintenance).then(() => {
                this.formLoading = false;
                this.maintenanceListModalOpen = false;
                this.maintenanceDeleteModalOpen = false;
                this.getData();

                this.$toast.add({
                    severity: 'success',
                    summary: 'Sikeres törlés!',
                    detail: 'A tűzoltó készülékhez tartozó karbantartás törlése sikeres.',
                    life: 5000
                });
            }).catch(error => {
                this.formLoading = false;

                this.$toast.add({
                    severity: 'error',
                    summary: 'Sikertelen törlés!',
                    detail: error.response.data.message,
                    life: 5000
                });
            })
        },
        createDocument() {
            this.documentDownload = true;

            this.apiService.createDocument().then(response => {
                this.documentDownload = false;
                window.open(response.data.url, '_blank');
            }).catch(error => {
                this.documentDownload = false;

                this.$toast.add({
                    severity: 'error',
                    summary: 'Sikertelen művelete!',
                    detail: error.response.data.message,
                    life: 5000
                });
            })
        },
    }
}
</script>

<style scoped>
</style>
